<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgAnalyticsJsuser2 extends JPlugin
{
	function plgAnalyticsJsuser2( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}
	
    function onGetChartTypes(&$data, $name) {
		
		if($name != 'jsuser2') return;
		
		$data = array('amline', 'ampie', 'amcolumn');
	}

	function onDrawChart( &$objChart, $name, &$params )
	{

		if($name != 'jsuser2') return;

		global $mainframe;

		$type = $params->get('chart_type');
		
	    if( !JComponentHelper::isEnabled('com_resource', true) ) {
			$errors = '<h3>Mighty Registration Component Not Exists or Not Enabled<h3>';
			return;
		}
		
	    $mparams = JComponentHelper::getParams('com_analytics');

		$objChart->setConfig('width',$mparams->get('width', 770));
		$objChart->setConfig('height',$params->get('height', 400));
		$objChart->setConfig('background.alpha',"1");
		$objChart->setConfig('preloader_color',"#999999");
		if( $type == 'ampie' ){
			$objChart->addLabel("<![CDATA[This graph shows Mighty Registration extended fields relationship]]>",20 ,385 , array('text_size' => 10));
			$objChart->addLabel("<![CDATA[<b>Mighty Registration extended fields<br>relationship</b>]]>",15 ,25 , array('text_size' => 16));
		}else{
			$objChart->addLabel("<![CDATA[This graph shows Mighty Registration extended fields progress]]>",20 ,385 , array('text_size' => 10));
			$objChart->addLabel("<![CDATA[<b>Mighty Registration extended fields progress</b>]]>",90 ,25 , array('text_size' => 16));
		}
	}
	
	function onGetForm(&$form, $name, $report, $params) 
	{
		if( $name != 'jsuser2' ) return;
		
		$report_params = new JParameter($report->params, JPATH_ROOT.DS.'plugins'.DS.'analytics'.DS.$params->get('type').'.xml');
		
		$group = 'Advanced params';
		
		if (!isset($report_params->_xml[$group])) {
			return false;
		}
		$elements= $report_params->renderToArray('params', $group);
		
		$doc = &JFactory::getDocument();
		$doc->addStyleDeclaration('
			.label {
				text-align: right;
				height: 30px;
			}
			.field select {
				width: 13em;
			}
		');
		
		$form .= '<table cellspacing="2" cellpadding="2">';

		if ($description = $report_params->_xml[$group]->attributes('description')) {
			// add the params description to the display
			$desc  = JText::_($description);
			$form .= '<tr><td class="paramlist_description" colspan="2">'.$desc.'</td></tr>';
		}
		
		if( !$report_params->get('user_chose_values') ){
		    unset($elements['values']);
		}

		foreach ($elements as $key => $element)
		{
			$form .= '<tr>';

			if ($element[0]) {
				$form .= '<td class="label"><span class="editlinktip">'.$element[0].'</span></td>';
				$form .= '<td  class="inputbox field">'.$element[1].'</td>';
			} else {
				$form .= '<td  class="inputbox field" colspan="2">'.$element[1].'</td>';
			}

			$form .= '</tr>';
		}

		if (count($element) < 1) {
			$form .= "<tr><td colspan=\"2\"><i>".JText::_('There are no Parameters for this item')."</i></td></tr>";
		}

		$form .= '</table>';
	}

	function onChartData( &$objChart, $name, $params )
	{
		if($name != 'jsuser2') return;

		$type = $params->get('chart_type');

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$from = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to   = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );

		$user_status   = $params->get( 'user_status', 'both' );

		$groupby  = $params->get( 'groupby', 'smonth' );
		$field = $params->get( 'field' );
		$values = $params->get( 'values' , false);
		$graphs = array();

		if( $values &&  !is_array($values) )
			$values = array($values);
		
		if ($type != 'ampie') {

    		$group_index = Array( "sday" => "DAYOFYEAR(u.registerDate)",
                        		"sweek"  => "WEEKOFYEAR(u.registerDate)",
                        		"smonth" => "MONTH(u.registerDate)",
                        		"syear"  => "YEAR(u.registerDate)");
    
    		$date_index = Array(  "sday"   => "DATE_FORMAT( u.registerDate, '%Y-%m-%d' )",
                        		"sweek"  => "DATE_FORMAT( u.registerDate - INTERVAL WEEKDAY(u.registerDate) DAY, '%Y-%m-%d' )",
                        		"smonth" => "DATE_FORMAT( u.registerDate, '%Y-%m-01' )",
                        		"syear"  => "DATE_FORMAT( u.registerDate, '%Y-01-01' )");
    		$sql_dates = ", {$date_index[$groupby]}  AS date_index,YEAR(u.registerDate) AS reg_year, {$group_index[$groupby]} AS group_index";
			$sql_group = 'reg_year, group_index,';
		} else {
		    $sql_dates = '';
			$sql_group = '';
		}
		$status_index = Array( "activated" => "AND u.block = 0",
                        		"blocked"   => "AND u.block = 1",
                        		"both"      => "");
		
		$sql = 'SELECT f.type FROM #__juser_extended_fields AS f WHERE f.id = '.$field;
		$db->setQuery($sql);
		$field_type = $db->loadResult();
		
		if ( $field_type != 'checkbox') {

			$sql = "    SELECT COUNT(d.id) AS amount, d.fvalue AS field_value"
			.$sql_dates
			."\n      FROM #__juser_extended_data AS d"
			."\n INNER JOIN #__users AS u ON u.id = d.user_id"
			."\n WHERE d.field_id = {$field} AND u.registerDate BETWEEN '{$from}' AND '{$to}' AND d.fvalue <> ''";
		    if ( $values )
			    $sql .= " AND d.fvalue IN ( '".implode( "', '", $values )."' ) ";
			$sql .= $status_index[$user_status];
			if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			    $sql .= " AND u.id = '$user_id'";
			$sql .= " \n GROUP BY ".$sql_group." field_value"
			."\n ORDER BY amount DESC, field_value"
			;
			
			$db->setQuery( $sql );
			$result = $db->loadObjectList();
			
			if( !$result || !is_array( $result ) ) return;
			
			if( $type != 'ampie' ) {
    			foreach ( $result AS $key => $row ) {
    				$graphs[$row->field_value][$row->date_index] = $row->amount;
    			}
			} else {
    			foreach ( $result AS $row ) {
    				$slices[$row->field_value] = $row->amount;
    			}
			}

		} else {
			$sql = "    SELECT COUNT(d.id) AS amount,d.fvalue AS field_value"
			.$sql_dates
			."\n      FROM #__juser_extended_data AS d"
			."\n LEFT JOIN #__users AS u ON u.id = d.user_id"
			."\n WHERE d.field_id = {$field} AND u.registerDate BETWEEN '{$from}' AND '{$to}' ".$status_index[$user_status];
			$sql .= ' AND ( 1 ';
			foreach ($values as $value) {
				$sql .= "OR (d.fvalue like  '%\n$value\n%'  OR d.fvalue like  '$value' OR d.fvalue like  '%\n$value' OR d.fvalue like  '$value\n%')";
			}
			$sql .= ') ';
			if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
				$sql .= " AND u.id = '$user_id'";
			$sql .= " \n GROUP BY ".$sql_group." field_value"
			;
			
			$db->setQuery( $sql );
			$result = $db->loadObjectList();
			
			if( !$result || !is_array( $result ) ) return;
			
			if( $type != 'ampie' ) {
    			foreach ( $result AS $key => $row ) {
    				$parse_str = explode("\n", $row->field_value);
    				foreach ($parse_str as $var) {
    					if ( in_array($var, $values))
    						$graphs[$var][$row->date_index] = $row->amount;
    				}
    			}
    			ksort($graphs);
			} else { 
			    
			    $sel_values = array();
				$chk_total = 0;
				
				foreach ( $result AS $k => $row ) {
					if( !$row->field_value ) continue;
					$parse_str = explode("\n", $row->field_value);
					foreach ($parse_str as $key => $var) {
						if ( in_array($var, $values))
							if( isset( $sel_values[$var] ) )
								$sel_values[$var] += (int)$row->amount;
							else
							 	$sel_values[$var] = (int)$row->amount;
					}
					$chk_total += $row->amount;
				}	
				$result = array();
				foreach ($sel_values as $key => $val) {
					$slices[$key] = $val;
				}
			}
		}
		
		if ($type != 'ampie') {

    		$current_date = $from;
    		$m = array();
    
    	    switch ( $groupby ) {
    			case "sday":
    				$format_series 		= '%Y %d %b';
    				break;
    			case "sweek" :
    				$timestamp = strtotime( $current_date );
    				$date_info = getdate($timestamp);
    				$timestamp -=  ($date_info['wday'] - 1) *60*60*24;
    				$current_date = date ( "Y-m-d", $timestamp );
    				$format_series      = '%Y %UW';
    				break;
    			case "smonth" :
    				preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
    				$timestamp = mktime (0, 0, 0, $m[2], 1, $m[1] );
    				$current_date = date ( "Y-m-d", $timestamp );
    				$format_series      = '%Y %b';
    				break;
    			case "syear" :
    				preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
    				$timestamp = mktime (0, 0, 0, 1, 1, $m[1] );
    				$current_date = date ( "Y-m-d", $timestamp );
    				$format_series      = '%Y';
    				break;
    		}
    		
    	    while ( strtotime( $current_date ) <= strtotime( $to ) ) {
    			$serie = strftime( $format_series, strtotime( $current_date ) );
    			$objChart->addSerie($current_date,$serie);
    			if ( $type == 'amline')
    			{
    				foreach( $graphs as $key => $graph) {
    					if( !isset($graphs[$key][$current_date]) ) {
    						$graphs[$key][$current_date] = " 0 ";
    					}
    				}
    			}
    			$current_date = $this->incrementDate( $current_date, $groupby );
    		}
    		
    		foreach( $graphs as $key => $graph ) {
    			$objChart->addGraph($key, $key, $graph, array( 
    				'balloon_text' => '<![CDATA[<b>{value}</b> {series}]]>'
    			));
    		}
		} else {
		    
		    $total = 0;
		    $k = 0;
		    
    		foreach ( $slices AS $fvalue => $amount ) {
    			if( !$fvalue ) continue;
    			$total += $amount;
    			$pulout = $k == 0 ? 'true' : 'false';
    			$objChart->addSlice($fvalue, $amount, array( 'pull_out' => $pulout, 'alpha' => 95) );
    			$k = 1;
    		}
    		
    		if ( $field_type == 'checkbox' ) 
    			$total = $chk_total;
    			
    		$sql2 = " SELECT COUNT(u.id) FROM #__users AS u WHERE u.registerDate BETWEEN '".$from."' AND '".$to."'".$status_index[$user_status] ;
    		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
    			$sql2 .= " AND id = '$user_id'";
    		$db->setQuery( $sql2 );
    		$amount_users = $db->loadResult();
    
    		if( $amount_users - $total > 0 ){
    		    $objChart->addSlice(JText::_('--Skip--'), $amount_users - $total, array( 'pull_out' => $pulout, 'alpha' => 95) );
    		}
		}
	}

	function onDrawTable(&$table, $name, $params)
	{
		if($name != 'jsuser2') return;

		$type = $params->get('chart_type');

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$from = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to   = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );

		$maxtablecolumn = $params->get( 'maxtablecolumn', 12 );
		$user_status   = $params->get( 'user_status', 'both' );
		$groupby = $params->get( 'groupby', 'smonth' );
		$sort_by = $params->get('sort_by');
		$limit = $params->get('limit', 0);

		$field = $params->get( 'field' );
		$values = $params->get( 'values' , false);

		if( !is_array($values) )
			$values = array($values);
			
		if ( empty($values) ) return;
		
		if( !is_int( $maxtablecolumn*1 ) ) return;
		
		$graphs = array();

	    if ($type != 'ampie') {

    		$group_index = Array( "sday" => "DAYOFYEAR(u.registerDate)",
                        		"sweek"  => "WEEKOFYEAR(u.registerDate)",
                        		"smonth" => "MONTH(u.registerDate)",
                        		"syear"  => "YEAR(u.registerDate)");
    
    		$date_index = Array(  "sday"   => "DATE_FORMAT( u.registerDate, '%Y-%m-%d' )",
                        		"sweek"  => "DATE_FORMAT( u.registerDate - INTERVAL WEEKDAY(u.registerDate) DAY, '%Y-%m-%d' )",
                        		"smonth" => "DATE_FORMAT( u.registerDate, '%Y-%m-01' )",
                        		"syear"  => "DATE_FORMAT( u.registerDate, '%Y-01-01' )");
    		$sql_dates = ", {$date_index[$groupby]}  AS date_index,YEAR(u.registerDate) AS reg_year, {$group_index[$groupby]} AS group_index";
			$sql_group = 'reg_year, group_index,';
		} else {
		    $sql_dates = '';
			$sql_group = '';
		}
		$status_index = Array( "activated" => "AND u.block = 0",
		"blocked"   => "AND u.block = 1",
		"both"      => "");
		
		$sql = 'SELECT f.type FROM #__juser_extended_fields AS f WHERE f.id = '.$field;
		$db->setQuery($sql);
		$field_type = $db->loadResult();
		
		if ( $field_type != 'checkbox') {
		    
            if( $type != 'ampie' ) {
    			$sql = "SELECT fvalue, count(*) as amount
    			FROM #__juser_extended_data  
    			WHERE field_id = ".$field.( !empty($values) ? " AND fvalue IN ('".implode("','",$values)."') " : "" )." AND fvalue <> ''";
    			$sql .= " GROUP BY fvalue 
    			ORDER BY amount DESC 
    			LIMIT 0, ".$maxtablecolumn;
    			$db->setQuery( $sql );
    			$fields = $db->loadObjectList();
    			if( !$fields) return;
    	
    			$field_str = "";
    			$i = 0;
    			foreach( $fields as $field_ ) {
    				$field_str .= ($i == 0 ? "" : ", " )."'".$field_->fvalue."'";
    				$i++;
    			}
    			
    			$sql_fields = " AND d.fvalue IN ( ".$field_str." )";
    			
            } else {
                if ( !empty($values) )
                    $sql_fields = " AND d.fvalue IN ( '".implode( "', '", $values )."'  )";
                else
                    $sql_fields = '';
            }
		    
	    	$sql = "    SELECT COUNT(d.id) AS amount, d.fvalue AS field_value"
			.$sql_dates
			."\n      FROM #__juser_extended_data AS d"
			."\n INNER JOIN #__users AS u ON u.id = d.user_id"
			."\n WHERE d.field_id = {$field} AND u.registerDate BETWEEN '{$from}' AND '{$to}'";
			
		    $sql .= $sql_fields;
			$sql .= $status_index[$user_status];
			if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			    $sql .= " AND u.id = '$user_id'";
			$sql .= " \n GROUP BY ".$sql_group." field_value"
			."\n ORDER BY amount DESC, field_value"
			;
			if($limit)
				$sql .= " LIMIT 0, $limit";
			
			$db->setQuery( $sql );
			$result = $db->loadObjectList();
			if( !$result || !is_array( $result ) ) return;
			
			if( $type != 'ampie' ) {
    			foreach ( $result AS $key => $row ) {
    				$graphs[$row->field_value][$row->date_index] = $row->amount;
    			}
			} else {
    			foreach ( $result AS $row ) {
    				$slices[$row->field_value] = $row->amount;
    			}
			}
		} else {
	    	$sql = "    SELECT COUNT(d.id) AS amount,d.fvalue AS field_value"
			.$sql_dates
			."\n      FROM #__juser_extended_data AS d"
			."\n LEFT JOIN #__users AS u ON u.id = d.user_id"
			."\n WHERE d.field_id = {$field} AND u.registerDate BETWEEN '{$from}' AND '{$to}' ".$status_index[$user_status];
			$sql .= ' AND ( 1 ';
			foreach ($values as $value) {
				$sql .= "OR (d.fvalue like  '%\n$value\n%'  OR d.fvalue like  '$value' OR d.fvalue like  '%\n$value' OR d.fvalue like  '$value\n%')";
			}
			$sql .= ') ';
			if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
				$sql .= " AND u.id = '$user_id'";
			$sql .= " \n GROUP BY ".$sql_group." field_value"
			;
			
			$db->setQuery( $sql );
			$result = $db->loadObjectList();
			
			if( !$result || !is_array( $result ) ) return;
			
			if( $type != 'ampie' ) {
    			foreach ( $result AS $key => $row ) {
    				$parse_str = explode("\n", $row->field_value);
    				foreach ($parse_str as $var) {
    					if ( in_array($var, $values))
    						$graphs[$var][$row->date_index] = $row->amount;
    				}
    			}
    			ksort($graphs);
			} else { 
			    
			    $sel_values = array();
				$chk_total = 0;
				
				foreach ( $result AS $k => $row ) {
					if( !$row->field_value ) continue;
					$parse_str = explode("\n", $row->field_value);
					foreach ($parse_str as $key => $var) {
						if ( in_array($var, $values))
							if( isset( $sel_values[$var] ) )
								$sel_values[$var] += (int)$row->amount;
							else
							 	$sel_values[$var] = (int)$row->amount;
					}
					$chk_total += $row->amount;
				}	
				foreach ($sel_values as $key => $val) {
					$slices[$key] = $val;
				}
			}
		}
		if ($type != 'ampie') {

    		$k     = 0;
    		$total = 0;
    
    		$out[] = '<table class="adminlist" cellspacing="0">';
    		$out[] = '<thead>';
    		$out[] = '<tr>';
    		$out[] = '<th width="1%">#</th>';
    		foreach( $graphs as $p => $graph) {
    			$out[] = '<th class="title">'.($p ? $p : '<i><big>'.JText::_('Skip').'</big></i>').'</th>';
    		}
    		$out[] = '<th width="1%">'.JText::_('Date').'</th>';
    		$out[] = '</tr>';
    		$out[] = '</thead>';
    		$out[] = '<tbody>';
    
    
    		$current_date = $from;
    		$m = array();
    		
    		switch ( $groupby ) {
    			case "sweek" :
    				$timestamp = strtotime( $current_date );
    				$date_info = getdate($timestamp);
    
    				$timestamp -= ($date_info['wday'] - 1) *60*60*24;
    				$current_date = date ( "Y-m-d", $timestamp );
    				break;
    			case "smonth" :
    				preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
    				$timestamp = mktime (0, 0, 0, $m[2], 1, $m[1] );
    				$current_date = date ( "Y-m-d", $timestamp );
    				break;
    			case "syear" :
    				preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
    				$timestamp = mktime (0, 0, 0, 1, 1, $m[1] );
    				$current_date = date ( "Y-m-d", $timestamp );
    				break;
    		}
    
    		$i = 0;
    
    		while ( strtotime( $current_date ) <= strtotime( $to ) ) {
    			$i++;
    			if($limit && $i > $limit) break;
    			$k = 1 - $k;
    			$out[] = "<tr class='row".$k."'>";
    			$out[] = "<td>".$i."</td>";
    			foreach( $graphs as $p => $graph) {
    				if( !isset($graphs[$p][$current_date]) ) {
    					$graphs[$p][$current_date] = '<font color="#ccc">0</font>';
    				}
    				if( !isset($graphs[$p]['total']) ){
    					$graphs[$p]['total'] = 0;
    				}
    				$graphs[$p]['total'] += $graphs[$p][$current_date];
    				$out[] = "<td>".$graphs[$p][$current_date]."</td>";
    
    			}
    			$out[] = "<td>".$current_date."</td>";
    			$out[] = "</tr>";
    
    			$current_date = $this->incrementDate( $current_date, $groupby );
    		}
    
    		$out[] = "<tr class='row".$k."'>";
    		$out[] = "<td><big><b>".JText::_('Total')."</b></big></td>";
    
    		foreach( $graphs as $p => $graph) {
    			$out[] = "<td><big><b>".$graphs[$p]['total']."<b></big></td>";
    
    		} 
    		$out[] = "<td></td>";
	    	$out[] = "</tr>";
	    	
		} else {
		    
		    $sql2 = " SELECT COUNT(id) FROM #__users WHERE registerDate BETWEEN '".$from."' AND '".$to."'" ;
    		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
    		$sql2 .= " AND id = '$user_id'";
    		$db->setQuery( $sql2 );
    		$amount_users = $db->loadResult();
    		
		    $k                  = 0;
    		$total              = 0;
    		$none_of_the_listed = 0;
    
    		$out[] = '<table class="adminlist" cellspacing="0">';
    		$out[] = '<thead>';
    		$out[] = '<tr>';
    		$out[] = '<th width="1%">#</th>';
    		$out[] = '<th class="title">'.JText::_('Field Value').'</th>';
    		$out[] = '<th width="1%">'.JText::_('Users').'</th>';
    		$out[] = '</tr>';
    		$out[] = '</thead>';
    		$out[] = '<tbody>';
    
    		$i = 1;
    		foreach ($slices AS $key => $value)
    		{
    			$total += $value;
    
    			if( $key == "" ) {
    				$none_of_the_listed += $value;
    				continue;
    			}
    			if( $limit  && $i <= $limit) {
    				
    				$k = 1 - $k;
    				$out[] = sprintf( "<tr class='row%d'><td>%d</td><td nowrap>%s</td><td align='right'>%s</td></tr>",
    				$k, $i, $key, $value);
    				$i ++ ;
    			}
    		}
    		if ( $type == 'checkbox' ) 
    			$total = $chk_total;
    
    		$out[] = sprintf( '<tr><td colspan="2" align="right"><b>%s</b></td><td><b><big>%s</big></b></td></tr>',
    		JText::_('Skip'), ( $none_of_the_listed + $amount_users - $total )	);
    
    		$out[] = sprintf( '<tr><td colspan="2" align="right"><b>%s</b></td><td><b><big>%s</big></b></td></tr>',
    		JText::_('Total'), $amount_users );
		}

		$out[] = '</tbody></table>';

		$table = implode( "", $out );

		if( $params->get( 'rep_xls' ) )
		{
			jimport('joomla.filesystem.file');
			$file = JPATH_ROOT.DS.'cache'.DS.$user->id.DS.$name.'.xls';
			JFile::write($file, $table);
		}
	}
	function onGetTotals($name, $params)
	{
		if($name != 'jsuser2') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$db = JFactory::getDBO();

		$from = $params->get('start', date('Y-m-d H:s:i', mktime(0,0,0, date('m')-1, date('d'), date('Y'))));
		$to = $params->get('finish', date('Y-m-d H:s:i', mktime(23,59,59, date('m'), date('d'), date('Y'))));
		$field = $params->get( 'field' );
		$user_status   = $params->get( 'user_status', 'both' );
		$values = $params->get( 'values' , false);

		if( $values && !is_array($values) )
			$values = array($values);
			
		$status_index = Array( "activated" => "AND u.block = 0",
		"blocked"   => "AND u.block = 1",
		"both"      => "");

		$totals = array();
		
		$sql = 'SELECT f.type FROM #__juser_extended_fields AS f WHERE f.id = '.$field;
		$db->setQuery($sql);
		$type = $db->loadResult();
		
		$sql = " SELECT Count(u.id) AS total, if( d.fvalue <> '' ,1,0) as value
		FROM #__users AS u
		Left Join #__juser_extended_data AS d ON d.user_id = u.id AND d.field_id = ".$field."
		WHERE 1 ".$status_index[$user_status];
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			$sql .= " AND u.id = '$user_id'";
		$sql .= " GROUP BY value";
		
		$db->setQuery( $sql );
		$dbtotals = $db->loadObjectList();
		
		if ( $type != 'checkbox') {
			
			$sql = " SELECT Count(u.id) AS total, if( d.fvalue ".( !empty($values) ? " IN ('".implode("','",$values)."') " : " <> '' " )." ,1,0) as value
			FROM #__users AS u
			Left Join #__juser_extended_data AS d ON d.user_id = u.id AND d.field_id = ".$field."
			WHERE 1 ".$status_index[$user_status];
			$sql .= " AND u.registerDate > '$from' AND u.registerDate < '$to'";
			if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
				$sql .= " AND u.id = '$user_id'";
			$sql .= " GROUP BY value";
			$db->setQuery( $sql );
			
			$current = $db->loadObjectList();
			
		} else {
			$sql = "    SELECT COUNT(u.id) AS total, if( d.fvalue <> '',1,0) as value"
			."\n      FROM #__users AS u"
			."\n LEFT JOIN #__juser_extended_data AS d ON u.id = d.user_id AND d.field_id = {$field}"
			."\n WHERE u.registerDate BETWEEN '{$from}' AND '{$to}' ".$status_index[$user_status];
			$sql .= ' AND ( 1 ';
			foreach ($values as $value) {
				$sql .= "OR (d.fvalue like  '%\n$value\n%'  OR d.fvalue like  '$value' OR d.fvalue like  '%\n$value' OR d.fvalue like  '$value\n%')";
			}
			$sql .= ') ';
			if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
				$sql .= " AND u.id = '$user_id'";
			$sql .= " \n GROUP BY value"
			;
			
			$db->setQuery( $sql );
			$current = $db->loadObjectList();
		}
		
		$all = 0;
		$current_have = $total_have = 0;
		$current_not_have = $total_not_have = 0;
		foreach ($dbtotals as $total) {
			$all += $total->total;
			($total->value == 1) ? $total_have = $total->total : $total_not_have = $total->total;
		}
		foreach($current as $val)
		{
			($val->value == 1) ? $current_have = $val->total : $current_not_have = $val->total;
		}
		
		if( !$all || !($current_have) ) return;
		
		$totals[0]['value'] = $all ;
		$totals[0]['text'] = JText::_( 'Total Users in DB');
		
		$totals[1]['value'] = $total_have;
		$totals[1]['text'] = JText::_( 'Total users with value in DB ').'('. round($total_have * 100 / $all, 1).'% '.JText::_('of total').')';
		
		$totals[2]['value'] = $current_have + $current_not_have;
		$totals[2]['text'] = JText::_( 'Total users in this report ').'('. round( ($current_have + $current_not_have) * 100 / $all, 1).'% '.JText::_('of total').')';
		
		$totals[3]['value'] = $current_have;
		$totals[3]['text'] = JText::_( 'Total report users with value ').'('. round( $current_have * 100 / ($current_have + $current_not_have), 1).'% '.JText::_('of total users in this report').')';
			
		return $totals;
	}
	
	function xajax_loadFieldValues( &$response, $value, $id, $rep_id ) {
		
		if( !$value ) 
			return null;
			
		$db = &JFactory::getDBO();
		$user = &JFactory::getUser();
		$options = '';
		
		$report = &JTable::getInstance('Report', 'Report');
		$report->load(array_pop($rep_id));
		$params = new JParameter($report->params);
		
		$sql = " SELECT DISTINCT d.fvalue AS value,  f.type
		FROM #__juser_extended_data AS d
		Inner Join #__juser_extended_fields AS f ON f.id = d.field_id
		WHERE d.field_id = ".$value."  AND d.fvalue <> ''";
		
		if ( $params->get('user_stick') )
		    $sql .= " AND d.user_id = ".$user->id;
				
		$sql .= " ORDER BY value ";
		
		$db->setQuery($sql);
		$result = $db->loadObjectList();
		
		$option = '';
		
		if ( $result ) {
			if ( $result[0]->type == 'checkbox' ){
				$values = array();
				foreach ( $result as $val ) {
					$values = array_merge( $values, explode("\n", $val->value) );
				}
				$values = array_unique($values);
				sort($values);
				$result = array();
				foreach ($values as $key => $var) {
					$result[$key] = new stdClass();
					$result[$key]->value = $var;
				}
			} 
			
		    foreach ($result as $val) {
				$option .='sel.options[sel.length] = new Option("'.$val->value.'", "'.$val->value.'",true);';
			}
		}
		$response->script( '
			$("'.$id.'").empty();
			sel = $("'.$id.'");
			'.$option
		);
		
		return $response;
	}
	
    function incrementDate( $date, $unit )
	{
		$eDate = getDate( strtotime( $date ) );

		switch ( $unit ) {
			case "sday":
				$eDate["mday"] ++;
				break;
			case "sweek":
				$eDate["mday"] += 7;
				break;
			case "smonth":
				$eDate["mon"] ++;
				break;
			case "syear":
				$eDate["year"] ++;
				break;
		}

		return  date( 'Y-m-d', mktime( $eDate["hours"], $eDate["minutes"], $eDate["seconds"], $eDate["mon"], $eDate["mday"], $eDate["year"] ) );
	}
}
?>